Index: trunk/sources/HeuristicLab.Core/3.3/Variable.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/Variable.cs	(revision 3317)
@@ -31,8 +31,8 @@
   [StorableClass]
   public sealed class Variable : NamedItem, IVariable {
+    [Storable]
     private IItem value;
     /// <inheritdoc/>
     /// <remarks>Calls <see cref="OnValueChanged"/> in the setter.</remarks>
-    [Storable]
     public IItem Value {
       get { return value; }
@@ -72,10 +72,17 @@
       : base(name) {
       this.value = value;
-      if (this.value != null) this.value.ToStringChanged += new EventHandler(Value_ToStringChanged);
+      Initialize();
     }
     public Variable(string name, string description, IItem value)
       : base(name, description) {
       this.value = value;
-      if (this.value != null) this.value.ToStringChanged += new EventHandler(Value_ToStringChanged);
+      Initialize();
+    }
+    [StorableConstructor]
+    private Variable(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (value != null) value.ToStringChanged += new EventHandler(Value_ToStringChanged);
     }
 
@@ -86,6 +93,9 @@
     /// <returns>The cloned object as <see cref="Variable"/>.</returns>
     public override IDeepCloneable Clone(Cloner cloner) {
-      Variable clone = new Variable(Name, Description, (IItem)cloner.Clone(value));
+      Variable clone = new Variable(Name, Description);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
+      clone.value = (IItem)cloner.Clone(value);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Core/3.3/VariableCollection.cs	(revision 3317)
@@ -33,6 +33,10 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      VariableCollection clone = new VariableCollection(this.Select(x => (IVariable)cloner.Clone(x)));
+      VariableCollection clone = new VariableCollection();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
+      foreach (string key in dict.Keys)
+        clone.dict.Add(key, (IVariable)cloner.Clone(dict[key]));
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs	(revision 3317)
@@ -62,5 +62,5 @@
         Caption = Content.ToString() + " (" + Content.GetType().Name + ")";
         valueCheckBox.Checked = Content.Value;
-        valueCheckBox.Enabled = true;
+        valueCheckBox.Enabled = !Content.ReadOnlyView;
       }
     }
Index: trunk/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs	(revision 3317)
@@ -62,5 +62,5 @@
         Caption = Content.ToString() + " (" + Content.GetType().Name + ")";
         valueComboBox.SelectedItem = Content.Value;
-        valueComboBox.Enabled = true;
+        valueComboBox.Enabled = !Content.ReadOnlyView;
       }
     }
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 3317)
@@ -90,4 +90,5 @@
         dataGridView.Columns[0].Width = dataGridView.Columns[0].GetPreferredWidth(DataGridViewAutoSizeColumnMode.AllCells, true);
       }
+      dataGridView.ReadOnly = Content.ReadOnlyView;
       dataGridView.Enabled = true;
     }
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 3317)
@@ -104,4 +104,5 @@
         UpdateColumnHeaders();
       }
+      dataGridView.ReadOnly = Content.ReadOnlyView;
       dataGridView.Enabled = true;
     }
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs	(revision 3317)
@@ -65,4 +65,5 @@
         Caption = Content.GetValue() + " (" + Content.GetType().Name + ")";
         valueTextBox.Text = Content.GetValue();
+        valueTextBox.ReadOnly = Content.ReadOnlyView;
         valueTextBox.Enabled = true;
       }
Index: trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/BoolArray.cs	(revision 3317)
@@ -35,4 +35,5 @@
       BoolArray clone = new BoolArray(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 3317)
@@ -39,7 +39,8 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       BoolMatrix clone = new BoolMatrix(matrix);
+      cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.ColumnNames = new List<string>(ColumnNames);
       clone.RowNames = new List<string>(RowNames);
-      cloner.RegisterClonedObject(this, clone);
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/BoolValue.cs	(revision 3317)
@@ -40,4 +40,5 @@
       BoolValue clone = new BoolValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/Comparison.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/Comparison.cs	(revision 3317)
@@ -39,4 +39,5 @@
       Comparison clone = new Comparison(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/DateTimeValue.cs	(revision 3317)
@@ -34,4 +34,5 @@
       DateTimeValue clone = new DateTimeValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 3317)
@@ -35,4 +35,5 @@
       DoubleArray clone = new DoubleArray(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 3317)
@@ -39,7 +39,8 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       DoubleMatrix clone = new DoubleMatrix(matrix);
+      cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.ColumnNames = new List<string>(ColumnNames);
       clone.RowNames = new List<string>(RowNames);
-      cloner.RegisterClonedObject(this, clone);
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 3317)
@@ -40,4 +40,5 @@
       DoubleValue clone = new DoubleValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleArray.cs	(revision 3317)
@@ -25,4 +25,5 @@
 namespace HeuristicLab.Data {
   public interface IStringConvertibleArray {
+    bool ReadOnlyView { get; set; }
     int Length { get; set; }
 
@@ -31,4 +32,5 @@
     bool SetValue(string value, int index);
 
+    event EventHandler ReadOnlyViewChanged;
     event EventHandler<EventArgs<int>> ItemChanged;
     event EventHandler Reset;
Index: trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrix.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrix.cs	(revision 3317)
@@ -26,4 +26,5 @@
 namespace HeuristicLab.Data {
   public interface IStringConvertibleMatrix {
+    bool ReadOnlyView { get; set; }
     int Rows { get; set; }
     int Columns { get; set; }
@@ -37,4 +38,5 @@
     bool SetValue(string value, int rowIndex, int columnIndex);
 
+    event EventHandler ReadOnlyViewChanged;
     event EventHandler<EventArgs<int, int>> ItemChanged;
     event EventHandler Reset;
Index: trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleValue.cs	(revision 3317)
@@ -24,8 +24,11 @@
 namespace HeuristicLab.Data {
   public interface IStringConvertibleValue {
+    bool ReadOnlyView { get; set; }
+
     bool Validate(string value, out string errorMessage);
     string GetValue();
     bool SetValue(string value);
 
+    event EventHandler ReadOnlyViewChanged;
     event EventHandler ValueChanged;
   }
Index: trunk/sources/HeuristicLab.Data/3.3/IntArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IntArray.cs	(revision 3317)
@@ -35,4 +35,5 @@
       IntArray clone = new IntArray(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 3317)
@@ -39,7 +39,8 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       IntMatrix clone = new IntMatrix(matrix);
+      cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.ColumnNames = new List<string>(ColumnNames);
       clone.RowNames = new List<string>(RowNames);
-      cloner.RegisterClonedObject(this, clone);
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/IntValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/IntValue.cs	(revision 3317)
@@ -40,4 +40,5 @@
       IntValue clone = new IntValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/PercentValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/PercentValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/PercentValue.cs	(revision 3317)
@@ -34,4 +34,5 @@
       PercentValue clone = new PercentValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/StringArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/StringArray.cs	(revision 3317)
@@ -80,4 +80,5 @@
       StringArray clone = new StringArray();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.array = (string[])array.Clone();
       return clone;
Index: trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 3317)
@@ -147,4 +147,5 @@
       StringMatrix clone = new StringMatrix();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.matrix = (string[,])matrix.Clone();
       clone.columnNames = new List<string>(columnNames);
Index: trunk/sources/HeuristicLab.Data/3.3/StringValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/StringValue.cs	(revision 3317)
@@ -57,4 +57,5 @@
       StringValue clone = new StringValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 3317)
@@ -35,4 +35,5 @@
       TimeSpanValue clone = new TimeSpanValue(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/BinaryVector.cs	(revision 3317)
@@ -44,4 +44,5 @@
       BinaryVector clone = new BinaryVector(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/TestRandom.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.BinaryVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3317)
@@ -112,5 +112,11 @@
     }
 
+    public bool ReadOnlyView {
+      get { throw new NotImplementedException(); }
+      set { throw new NotImplementedException(); }
+    }
+
     public event EventHandler ItemImageChanged;
+    public event EventHandler ReadOnlyViewChanged;
     public event EventHandler ToStringChanged;
 
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/IntegerVector.cs	(revision 3317)
@@ -44,4 +44,5 @@
       IntegerVector clone = new IntegerVector(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/TestRandom.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.IntegerVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3317)
@@ -112,5 +112,11 @@
     }
 
+    public bool ReadOnlyView {
+      get { throw new NotImplementedException(); }
+      set { throw new NotImplementedException(); }
+    }
+
     public event EventHandler ItemImageChanged;
+    public event EventHandler ReadOnlyViewChanged;
     public event EventHandler ToStringChanged;
 
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Permutation.cs	(revision 3317)
@@ -65,4 +65,5 @@
       Permutation clone = new Permutation(permutationType, array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationType.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationType.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/PermutationType.cs	(revision 3317)
@@ -34,4 +34,5 @@
       PermutationType clone = new PermutationType(value);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Random.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Random.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.PermutationEncoding/3.3/Tests/Random.cs	(revision 3317)
@@ -112,5 +112,11 @@
     }
 
+    public bool ReadOnlyView {
+      get { throw new NotImplementedException(); }
+      set { throw new NotImplementedException(); }
+    }
+
     public event EventHandler ItemImageChanged;
+    public event EventHandler ReadOnlyViewChanged;
     public event EventHandler ToStringChanged;
 
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVector.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVector.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/RealVector.cs	(revision 3317)
@@ -44,4 +44,5 @@
       RealVector clone = new RealVector(array);
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       return clone;
     }
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/TestRandom.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Tests/TestRandom.cs	(revision 3317)
@@ -112,5 +112,11 @@
     }
 
+    public bool ReadOnlyView {
+      get { throw new NotImplementedException(); }
+      set { throw new NotImplementedException(); }
+    }
+
     public event EventHandler ItemImageChanged;
+    public event EventHandler ReadOnlyViewChanged;
     public event EventHandler ToStringChanged;
 
Index: trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.3/SymbolicExpressionTree.cs	(revision 3317)
@@ -99,4 +99,5 @@
       SymbolicExpressionTree clone = new SymbolicExpressionTree();
       cloner.RegisterClonedObject(this, clone);
+      clone.ReadOnlyView = ReadOnlyView;
       clone.root = (SymbolicExpressionTreeNode)this.root.Clone();
       clone.allowedFunctionsInBranch = new Dictionary<int, IEnumerable<string>>(allowedFunctionsInBranch);
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 3317)
@@ -418,5 +418,5 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       ProgrammableOperator clone = (ProgrammableOperator)base.Clone(cloner);
-      clone.Description = Description;
+      clone.description = description;
       clone.code = Code;
       clone.executeMethod = executeMethod;
Index: trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Operators/3.3/MultipleCallsOperator.cs	(revision 3317)
@@ -37,23 +37,21 @@
     private List<IValueParameter<IOperator>> operatorParameters;
 
+    [Storable]
     private OperatorList operators;
-    [Storable]
     public OperatorList Operators {
       get { return operators; }
-      private set {
-        if (operators != null) DeregisterOperatorsEvents();
-        operators = value;
-        if (operators != null) RegisterOperatorsEvents();
-      }
     }
 
     public MultipleCallsOperator()
       : base() {
-      Operators = new OperatorList();
+      operators = new OperatorList();
       Initialize();
     }
+    [StorableConstructor]
+    protected MultipleCallsOperator(bool deserializing) : base(deserializing) { }
 
     [StorableHook(HookType.AfterDeserialization)]
     private void Initialize() {
+      if (operators != null) RegisterOperatorsEvents();
       operatorParameters = new List<IValueParameter<IOperator>>();
       for (int i = 0; i < Operators.Count; i++) {
@@ -66,5 +64,5 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       MultipleCallsOperator clone = (MultipleCallsOperator)base.Clone(cloner);
-      clone.Operators = (OperatorList)cloner.Clone(operators);
+      clone.operators = (OperatorList)cloner.Clone(operators);
       clone.Initialize();
       return clone;
Index: trunk/sources/HeuristicLab.Operators/3.3/Operator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Operators/3.3/Operator.cs	(revision 3317)
@@ -113,4 +113,6 @@
       breakpoint = false;
     }
+    [StorableConstructor]
+    protected Operator(bool deserializing) : base(deserializing) { }
 
     /// <summary>
Index: trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Operators/3.3/SingleSuccessorOperator.cs	(revision 3317)
@@ -43,4 +43,6 @@
       Parameters.Add(new OperatorParameter("Successor", "Operator which is executed next."));
     }
+    [StorableConstructor]
+    protected SingleSuccessorOperator(bool deserializing) : base(deserializing) { }
 
     public override IOperation Apply() {
Index: trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 3317)
@@ -31,24 +31,29 @@
   [StorableClass]
   public abstract class ValuesCollector : SingleSuccessorOperator, IOperator {
+    [Storable]
     private ParameterCollection collectedValues;
-    [Storable]
     public ParameterCollection CollectedValues {
       get { return collectedValues; }
-      private set {
-        collectedValues = value;
-        collectedValues.ItemsAdded += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsAdded);
-        collectedValues.ItemsRemoved += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsRemoved);
-        collectedValues.CollectionReset += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_CollectionReset);
-      }
     }
 
     public ValuesCollector()
       : base() {
-      CollectedValues = new ParameterCollection();
+      collectedValues = new ParameterCollection();
+      Initialize();
+    }
+    [StorableConstructor]
+    protected ValuesCollector(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      collectedValues.ItemsAdded += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsAdded);
+      collectedValues.ItemsRemoved += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsRemoved);
+      collectedValues.CollectionReset += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_CollectionReset);
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       ValuesCollector clone = (ValuesCollector)base.Clone(cloner);
-      clone.CollectedValues = (ParameterCollection)cloner.Clone(collectedValues);
+      clone.collectedValues = (ParameterCollection)cloner.Clone(collectedValues);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Optimization/3.3/OptimizerList.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/OptimizerList.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Optimization/3.3/OptimizerList.cs	(revision 3317)
@@ -33,10 +33,4 @@
     public OptimizerList(int capacity) : base(capacity) { }
     public OptimizerList(IEnumerable<IOptimizer> collection) : base(collection) { }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      OptimizerList clone = new OptimizerList(this.Select(x => (IOptimizer)cloner.Clone(x)));
-      cloner.RegisterClonedObject(this, clone);
-      return clone;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Optimization/3.3/Result.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/Result.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Optimization/3.3/Result.cs	(revision 3317)
@@ -45,6 +45,6 @@
     }
 
+    [Storable]
     private IItem value;
-    [Storable]
     public IItem Value {
       get { return value; }
@@ -84,5 +84,5 @@
       this.dataType = value == null ? typeof(IItem) : value.GetType();
       this.value = value;
-      if (this.value != null) this.value.ToStringChanged += new EventHandler(Value_ToStringChanged);
+      Initialize();
     }
     public Result(string name, string description, IItem value)
@@ -90,11 +90,20 @@
       this.dataType = value == null ? typeof(IItem) : value.GetType();
       this.value = value;
-      if (this.value != null) this.value.ToStringChanged += new EventHandler(Value_ToStringChanged);
+      Initialize();
+    }
+    [StorableConstructor]
+    private Result(bool deserializing) : base(deserializing) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (value != null) value.ToStringChanged += new EventHandler(Value_ToStringChanged);
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      Result clone = new Result(Name, Description, (IItem)cloner.Clone(value));
+      Result clone = new Result(Name, Description, DataType);
       cloner.RegisterClonedObject(this, clone);
-      clone.dataType = dataType;
+      clone.ReadOnlyView = ReadOnlyView;
+      clone.value = (IItem)cloner.Clone(value);
+      clone.Initialize();
       return clone;
     }
Index: trunk/sources/HeuristicLab.Optimization/3.3/ResultCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/ResultCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Optimization/3.3/ResultCollection.cs	(revision 3317)
@@ -32,10 +32,4 @@
     public ResultCollection(int capacity) : base(capacity) { }
     public ResultCollection(IEnumerable<IResult> collection) : base(collection) { }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      ResultCollection clone = new ResultCollection(this.Select(x => (IResult)cloner.Clone(x)));
-      cloner.RegisterClonedObject(this, clone);
-      return clone;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Optimization/3.3/RunCollection.cs	(revision 3317)
@@ -32,10 +32,4 @@
     public RunCollection(int capacity) : base(capacity) { }
     public RunCollection(IEnumerable<IRun> collection) : base(collection) { }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      RunCollection clone = new RunCollection(this.Select(x => (IRun)cloner.Clone(x)));
-      cloner.RegisterClonedObject(this, clone);
-      return clone;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs
===================================================================
--- trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs	(revision 3316)
+++ trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs	(revision 3317)
@@ -71,4 +71,6 @@
       this.actualName = actualName == null ? string.Empty : actualName;
     }
+    [StorableConstructor]
+    protected LookupParameter(bool deserializing) : base(deserializing) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
